Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -4774,443 +4723,139 @@
 void ImGui::SetItemAllowOverlap()
 {
-   ImGuiContext& g = *GImGui;
-   if (g.HoveredId == g.CurrentWindow->DC.LastItemId)
-      g.HoveredIdAllowOverlap = true;
-   if (g.ActiveId == g.CurrentWindow->DC.LastItemId)
-      g.ActiveIdAllowOverlap = true;
+    ImGuiContext& g = *GImGui;
+    if (g.HoveredId == g.CurrentWindow->DC.LastItemId)
+        g.HoveredIdAllowOverlap = true;
+    if (g.ActiveId == g.CurrentWindow->DC.LastItemId)
+        g.ActiveIdAllowOverlap = true;
 }
 
 ImVec2 ImGui::GetItemRectMin()
 {
-   ImGuiWindow* window = GetCurrentWindowRead();
-   return window->DC.LastItemRect.Min;
+    ImGuiWindow* window = GetCurrentWindowRead();
+    return window->DC.LastItemRect.Min;
 }
 
 ImVec2 ImGui::GetItemRectMax()
 {
-   ImGuiWindow* window = GetCurrentWindowRead();
-   return window->DC.LastItemRect.Max;
+    ImGuiWindow* window = GetCurrentWindowRead();
+    return window->DC.LastItemRect.Max;
 }
 
 ImVec2 ImGui::GetItemRectSize()
 {
-   ImGuiWindow* window = GetCurrentWindowRead();
-   return window->DC.LastItemRect.GetSize();
+    ImGuiWindow* window = GetCurrentWindowRead();
+    return window->DC.LastItemRect.GetSize();
 }
 
 static ImRect GetViewportRect()
 {
-   ImGuiContext& g = *GImGui;
-   if (g.IO.DisplayVisibleMin.x != g.IO.DisplayVisibleMax.x && g.IO.DisplayVisibleMin.y != g.IO.DisplayVisibleMax.y)
-      return ImRect(g.IO.DisplayVisibleMin, g.IO.DisplayVisibleMax);
-   return ImRect(0.0f, 0.0f, g.IO.DisplaySize.x, g.IO.DisplaySize.y);
-}
-
-// Not exposed publicly as BeginTooltip() because bool parameters are evil. Let's see if other needs arise first.
-void ImGui::BeginTooltipEx(ImGuiWindowFlags extra_flags, bool override_previous_tooltip)
-{
-   ImGuiContext& g = *GImGui;
-   char window_name[16];
-   ImFormatString(window_name, IM_ARRAYSIZE(window_name), "##Tooltip_%02d", g.TooltipOverrideCount);
-   if (override_previous_tooltip)
-      if (ImGuiWindow* window = FindWindowByName(window_name))
-         if (window->Active)
-         {
-            // Hide previous tooltip from being displayed. We can't easily "reset" the content of a window so we create a new one.
-            window->HiddenFrames = 1;
-            ImFormatString(window_name, IM_ARRAYSIZE(window_name), "##Tooltip_%02d", ++g.TooltipOverrideCount);
-         }
-   ImGuiWindowFlags flags = ImGuiWindowFlags_Tooltip | ImGuiWindowFlags_NoInputs | ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoMove | ImGuiWindowFlags_NoResize | ImGuiWindowFlags_NoSavedSettings | ImGuiWindowFlags_AlwaysAutoResize | ImGuiWindowFlags_NoNav;
-   Begin(window_name, NULL, flags | extra_flags);
-}
-
-void ImGui::SetTooltipV(const char* fmt, va_list args)
-{
-   BeginTooltipEx(0, true);
-   TextV(fmt, args);
-   EndTooltip();
-}
-
-void ImGui::SetTooltip(const char* fmt, ...)
-{
-   va_list args;
-   va_start(args, fmt);
-   SetTooltipV(fmt, args);
-   va_end(args);
-}
-
-void ImGui::BeginTooltip()
-{
-   BeginTooltipEx(0, false);
-}
-
-void ImGui::EndTooltip()
-{
-   IM_ASSERT(GetCurrentWindowRead()->Flags & ImGuiWindowFlags_Tooltip);   // Mismatched BeginTooltip()/EndTooltip() calls
-   End();
-}
-
-// Mark popup as open (toggle toward open state).
-// Popups are closed when user click outside, or activate a pressable item, or CloseCurrentPopup() is called within a BeginPopup()/EndPopup() block.
-// Popup identifiers are relative to the current ID-stack (so OpenPopup and BeginPopup needs to be at the same level).
-// One open popup per level of the popup hierarchy (NB: when assigning we reset the Window member of ImGuiPopupRef to NULL)
-void ImGui::OpenPopupEx(ImGuiID id)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* parent_window = g.CurrentWindow;
-   int current_stack_size = g.CurrentPopupStack.Size;
-   ImGuiPopupRef popup_ref; // Tagged as new ref as Window will be set back to NULL if we write this into OpenPopupStack.
-   popup_ref.PopupId = id;
-   popup_ref.Window = NULL;
-   popup_ref.ParentWindow = parent_window;
-   popup_ref.OpenFrameCount = g.FrameCount;
-   popup_ref.OpenParentId = parent_window->IDStack.back();
-   popup_ref.OpenMousePos = g.IO.MousePos;
-   popup_ref.OpenPopupPos = NavCalcPreferredRefPos();
-
-   //printf("[%05d] OpenPopupEx(0x%08X)\n", g.FrameCount, id);
-   if (g.OpenPopupStack.Size < current_stack_size + 1)
-   {
-      g.OpenPopupStack.push_back(popup_ref);
-   }
-   else
-   {
-      // Close child popups if any
-      g.OpenPopupStack.resize(current_stack_size + 1);
-
-      // Gently handle the user mistakenly calling OpenPopup() every frame. It is a programming mistake! However, if we were to run the regular code path, the ui
-      // would become completely unusable because the popup will always be in hidden-while-calculating-size state _while_ claiming focus. Which would be a very confusing
-      // situation for the programmer. Instead, we silently allow the popup to proceed, it will keep reappearing and the programming error will be more obvious to understand. 
-      if (g.OpenPopupStack[current_stack_size].PopupId == id && g.OpenPopupStack[current_stack_size].OpenFrameCount == g.FrameCount - 1)
-         g.OpenPopupStack[current_stack_size].OpenFrameCount = popup_ref.OpenFrameCount;
-      else
-         g.OpenPopupStack[current_stack_size] = popup_ref;
-
-      // When reopening a popup we first refocus its parent, otherwise if its parent is itself a popup it would get closed by ClosePopupsOverWindow().
-      // This is equivalent to what ClosePopupToLevel() does.
-      //if (g.OpenPopupStack[current_stack_size].PopupId == id)
-      //    FocusWindow(parent_window);
-   }
-}
-
-void ImGui::OpenPopup(const char* str_id)
-{
-   ImGuiContext& g = *GImGui;
-   OpenPopupEx(g.CurrentWindow->GetID(str_id));
-}
-
-void ImGui::ClosePopupsOverWindow(ImGuiWindow* ref_window)
-{
-   ImGuiContext& g = *GImGui;
-   if (g.OpenPopupStack.empty())
-      return;
-
-   // When popups are stacked, clicking on a lower level popups puts focus back to it and close popups above it.
-   // Don't close our own child popup windows.
-   int n = 0;
-   if (ref_window)
-   {
-      for (n = 0; n < g.OpenPopupStack.Size; n++)
-      {
-         ImGuiPopupRef& popup = g.OpenPopupStack[n];
-         if (!popup.Window)
-            continue;
-         IM_ASSERT((popup.Window->Flags & ImGuiWindowFlags_Popup) != 0);
-         if (popup.Window->Flags & ImGuiWindowFlags_ChildWindow)
-            continue;
-
-         // Trim the stack if popups are not direct descendant of the reference window (which is often the NavWindow)
-         bool has_focus = false;
-         for (int m = n; m < g.OpenPopupStack.Size && !has_focus; m++)
-            has_focus = (g.OpenPopupStack[m].Window && g.OpenPopupStack[m].Window->RootWindow == ref_window->RootWindow);
-         if (!has_focus)
-            break;
-      }
-   }
-   if (n < g.OpenPopupStack.Size) // This test is not required but it allows to set a convenient breakpoint on the block below
-      ClosePopupToLevel(n);
-}
-
-ImGuiWindow* ImGui::GetFrontMostPopupModal()
-{
-   ImGuiContext& g = *GImGui;
-   for (int n = g.OpenPopupStack.Size - 1; n >= 0; n--)
-      if (ImGuiWindow* popup = g.OpenPopupStack.Data[n].Window)
-         if (popup->Flags & ImGuiWindowFlags_Modal)
-            return popup;
-   return NULL;
-}
-
-static void ClosePopupToLevel(int remaining)
-{
-   IM_ASSERT(remaining >= 0);
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* focus_window = (remaining > 0) ? g.OpenPopupStack[remaining - 1].Window : g.OpenPopupStack[0].ParentWindow;
-   if (g.NavLayer == 0)
-      focus_window = NavRestoreLastChildNavWindow(focus_window);
-   ImGui::FocusWindow(focus_window);
-   focus_window->DC.NavHideHighlightOneFrame = true;
-   g.OpenPopupStack.resize(remaining);
-}
-
-void ImGui::ClosePopup(ImGuiID id)
-{
-   if (!IsPopupOpen(id))
-      return;
-   ImGuiContext& g = *GImGui;
-   ClosePopupToLevel(g.OpenPopupStack.Size - 1);
-}
-
-// Close the popup we have begin-ed into.
-void ImGui::CloseCurrentPopup()
-{
-   ImGuiContext& g = *GImGui;
-   int popup_idx = g.CurrentPopupStack.Size - 1;
-   if (popup_idx < 0 || popup_idx >= g.OpenPopupStack.Size || g.CurrentPopupStack[popup_idx].PopupId != g.OpenPopupStack[popup_idx].PopupId)
-      return;
-   while (popup_idx > 0 && g.OpenPopupStack[popup_idx].Window && (g.OpenPopupStack[popup_idx].Window->Flags & ImGuiWindowFlags_ChildMenu))
-      popup_idx--;
-   ClosePopupToLevel(popup_idx);
-}
-
-bool ImGui::BeginPopupEx(ImGuiID id, ImGuiWindowFlags extra_flags)
-{
-   ImGuiContext& g = *GImGui;
-   if (!IsPopupOpen(id))
-   {
-      g.NextWindowData.Clear(); // We behave like Begin() and need to consume those values
-      return false;
-   }
-
-   char name[20];
-   if (extra_flags & ImGuiWindowFlags_ChildMenu)
-      ImFormatString(name, IM_ARRAYSIZE(name), "##Menu_%02d", g.CurrentPopupStack.Size);    // Recycle windows based on depth
-   else
-      ImFormatString(name, IM_ARRAYSIZE(name), "##Popup_%08x", id); // Not recycling, so we can close/open during the same frame
-
-   bool is_open = Begin(name, NULL, extra_flags | ImGuiWindowFlags_Popup);
-   if (!is_open) // NB: Begin can return false when the popup is completely clipped (e.g. zero size display)
-      EndPopup();
-
-   return is_open;
-}
-
-bool ImGui::BeginPopup(const char* str_id, ImGuiWindowFlags flags)
-{
-   ImGuiContext& g = *GImGui;
-   if (g.OpenPopupStack.Size <= g.CurrentPopupStack.Size) // Early out for performance
-   {
-      g.NextWindowData.Clear(); // We behave like Begin() and need to consume those values
-      return false;
-   }
-   return BeginPopupEx(g.CurrentWindow->GetID(str_id), flags | ImGuiWindowFlags_AlwaysAutoResize | ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoSavedSettings);
-}
-
-bool ImGui::IsPopupOpen(ImGuiID id)
-{
-   ImGuiContext& g = *GImGui;
-   return g.OpenPopupStack.Size > g.CurrentPopupStack.Size && g.OpenPopupStack[g.CurrentPopupStack.Size].PopupId == id;
-}
-
-bool ImGui::IsPopupOpen(const char* str_id)
-{
-   ImGuiContext& g = *GImGui;
-   return g.OpenPopupStack.Size > g.CurrentPopupStack.Size && g.OpenPopupStack[g.CurrentPopupStack.Size].PopupId == g.CurrentWindow->GetID(str_id);
-}
-
-bool ImGui::BeginPopupModal(const char* name, bool* p_open, ImGuiWindowFlags flags)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   const ImGuiID id = window->GetID(name);
-   if (!IsPopupOpen(id))
-   {
-      g.NextWindowData.Clear(); // We behave like Begin() and need to consume those values
-      return false;
-   }
-
-   // Center modal windows by default
-   // FIXME: Should test for (PosCond & window->SetWindowPosAllowFlags) with the upcoming window.
-   if (g.NextWindowData.PosCond == 0)
-      SetNextWindowPos(g.IO.DisplaySize * 0.5f, ImGuiCond_Appearing, ImVec2(0.5f, 0.5f));
-
-   bool is_open = Begin(name, p_open, flags | ImGuiWindowFlags_Popup | ImGuiWindowFlags_Modal | ImGuiWindowFlags_NoCollapse | ImGuiWindowFlags_NoSavedSettings);
-   if (!is_open || (p_open && !*p_open)) // NB: is_open can be 'false' when the popup is completely clipped (e.g. zero size display)
-   {
-      EndPopup();
-      if (is_open)
-         ClosePopup(id);
-      return false;
-   }
-
-   return is_open;
-}
-
-static void NavProcessMoveRequestWrapAround(ImGuiWindow* window)
-{
-   ImGuiContext& g = *GImGui;
-   if (g.NavWindow == window && NavMoveRequestButNoResultYet())
-      if ((g.NavMoveDir == ImGuiDir_Up || g.NavMoveDir == ImGuiDir_Down) && g.NavMoveRequestForward == ImGuiNavForward_None && g.NavLayer == 0)
-      {
-         g.NavMoveRequestForward = ImGuiNavForward_ForwardQueued;
-         ImGui::NavMoveRequestCancel();
-         g.NavWindow->NavRectRel[0].Min.y = g.NavWindow->NavRectRel[0].Max.y = ((g.NavMoveDir == ImGuiDir_Up) ? ImMax(window->SizeFull.y, window->SizeContents.y) : 0.0f) - window->Scroll.y;
-      }
-}
-
-void ImGui::EndPopup()
-{
-   ImGuiContext& g = *GImGui; (void)g;
-   IM_ASSERT(g.CurrentWindow->Flags & ImGuiWindowFlags_Popup);  // Mismatched BeginPopup()/EndPopup() calls
-   IM_ASSERT(g.CurrentPopupStack.Size > 0);
-
-   // Make all menus and popups wrap around for now, may need to expose that policy.
-   NavProcessMoveRequestWrapAround(g.CurrentWindow);
-
-   End();
-}
-
-bool ImGui::OpenPopupOnItemClick(const char* str_id, int mouse_button)
-{
-   ImGuiWindow* window = GImGui->CurrentWindow;
-   if (IsMouseReleased(mouse_button) && IsItemHovered(ImGuiHoveredFlags_AllowWhenBlockedByPopup))
-   {
-      ImGuiID id = str_id ? window->GetID(str_id) : window->DC.LastItemId; // If user hasn't passed an ID, we can use the LastItemID. Using LastItemID as a Popup ID won't conflict!
-      IM_ASSERT(id != 0);                                                  // However, you cannot pass a NULL str_id if the last item has no identifier (e.g. a Text() item)
-      OpenPopupEx(id);
-      return true;
-   }
-   return false;
-}
-
-// This is a helper to handle the simplest case of associating one named popup to one given widget.
-// You may want to handle this on user side if you have specific needs (e.g. tweaking IsItemHovered() parameters).
-// You can pass a NULL str_id to use the identifier of the last item.
-bool ImGui::BeginPopupContextItem(const char* str_id, int mouse_button)
-{
-   ImGuiWindow* window = GImGui->CurrentWindow;
-   ImGuiID id = str_id ? window->GetID(str_id) : window->DC.LastItemId; // If user hasn't passed an ID, we can use the LastItemID. Using LastItemID as a Popup ID won't conflict!
-   IM_ASSERT(id != 0);                                                  // However, you cannot pass a NULL str_id if the last item has no identifier (e.g. a Text() item)
-   if (IsMouseReleased(mouse_button) && IsItemHovered(ImGuiHoveredFlags_AllowWhenBlockedByPopup))
-      OpenPopupEx(id);
-   return BeginPopupEx(id, ImGuiWindowFlags_AlwaysAutoResize | ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoSavedSettings);
-}
-
-bool ImGui::BeginPopupContextWindow(const char* str_id, int mouse_button, bool also_over_items)
-{
-   if (!str_id)
-      str_id = "window_context";
-   ImGuiID id = GImGui->CurrentWindow->GetID(str_id);
-   if (IsMouseReleased(mouse_button) && IsWindowHovered(ImGuiHoveredFlags_AllowWhenBlockedByPopup))
-      if (also_over_items || !IsAnyItemHovered())
-         OpenPopupEx(id);
-   return BeginPopupEx(id, ImGuiWindowFlags_AlwaysAutoResize | ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoSavedSettings);
-}
-
-bool ImGui::BeginPopupContextVoid(const char* str_id, int mouse_button)
-{
-   if (!str_id)
-      str_id = "void_context";
-   ImGuiID id = GImGui->CurrentWindow->GetID(str_id);
-   if (IsMouseReleased(mouse_button) && !IsWindowHovered(ImGuiHoveredFlags_AnyWindow))
-      OpenPopupEx(id);
-   return BeginPopupEx(id, ImGuiWindowFlags_AlwaysAutoResize | ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoSavedSettings);
-}
-
-static bool BeginChildEx(const char* name, ImGuiID id, const ImVec2& size_arg, bool border, ImGuiWindowFlags extra_flags)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* parent_window = ImGui::GetCurrentWindow();
-   ImGuiWindowFlags flags = ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoResize | ImGuiWindowFlags_NoSavedSettings | ImGuiWindowFlags_ChildWindow;
-   flags |= (parent_window->Flags & ImGuiWindowFlags_NoMove);  // Inherit the NoMove flag
-
-   const ImVec2 content_avail = ImGui::GetContentRegionAvail();
-   ImVec2 size = ImFloor(size_arg);
-   const int auto_fit_axises = ((size.x == 0.0f) ? (1 << ImGuiAxis_X) : 0x00) | ((size.y == 0.0f) ? (1 << ImGuiAxis_Y) : 0x00);
-   if (size.x <= 0.0f)
-      size.x = ImMax(content_avail.x + size.x, 4.0f); // Arbitrary minimum child size (0.0f causing too much issues)
-   if (size.y <= 0.0f)
-      size.y = ImMax(content_avail.y + size.y, 4.0f);
-
-   const float backup_border_size = g.Style.ChildBorderSize;
-   if (!border)
-      g.Style.ChildBorderSize = 0.0f;
-   flags |= extra_flags;
-
-   char title[256];
-   if (name)
-      ImFormatString(title, IM_ARRAYSIZE(title), "%s/%s", parent_window->Name, name);
-   else
-      ImFormatString(title, IM_ARRAYSIZE(title), "%s/%08X", parent_window->Name, id);
-
-   ImGui::SetNextWindowSize(size);
-   bool ret = ImGui::Begin(title, NULL, flags);
-   ImGuiWindow* child_window = ImGui::GetCurrentWindow();
-   child_window->ChildId = id;
-   child_window->AutoFitChildAxises = auto_fit_axises;
-   g.Style.ChildBorderSize = backup_border_size;
-
-   // Process navigation-in immediately so NavInit can run on first frame
-   if (!(flags & ImGuiWindowFlags_NavFlattened) && (child_window->DC.NavLayerActiveMask != 0 || child_window->DC.NavHasScroll) && g.NavActivateId == id)
-   {
-      ImGui::FocusWindow(child_window);
-      ImGui::NavInitWindow(child_window, false);
-      ImGui::SetActiveID(id + 1, child_window); // Steal ActiveId with a dummy id so that key-press won't activate child item
-      g.ActiveIdSource = ImGuiInputSource_Nav;
-   }
-
-   return ret;
+    ImGuiContext& g = *GImGui;
+    return ImRect(0.0f, 0.0f, g.IO.DisplaySize.x, g.IO.DisplaySize.y);
+}
+
+bool ImGui::BeginChildEx(const char* name, ImGuiID id, const ImVec2& size_arg, bool border, ImGuiWindowFlags flags)
+{
+    ImGuiContext& g = *GImGui;
+    ImGuiWindow* parent_window = g.CurrentWindow;
+
+    flags |= ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoResize | ImGuiWindowFlags_NoSavedSettings | ImGuiWindowFlags_ChildWindow;
+    flags |= (parent_window->Flags & ImGuiWindowFlags_NoMove);  // Inherit the NoMove flag
+
+    // Size
+    const ImVec2 content_avail = GetContentRegionAvail();
+    ImVec2 size = ImFloor(size_arg);
+    const int auto_fit_axises = ((size.x == 0.0f) ? (1 << ImGuiAxis_X) : 0x00) | ((size.y == 0.0f) ? (1 << ImGuiAxis_Y) : 0x00);
+    if (size.x <= 0.0f)
+        size.x = ImMax(content_avail.x + size.x, 4.0f); // Arbitrary minimum child size (0.0f causing too much issues)
+    if (size.y <= 0.0f)
+        size.y = ImMax(content_avail.y + size.y, 4.0f);
+    SetNextWindowSize(size);
+
+    // Build up name. If you need to append to a same child from multiple location in the ID stack, use BeginChild(ImGuiID id) with a stable value.
+    char title[256];
+    if (name)
+        ImFormatString(title, IM_ARRAYSIZE(title), "%s/%s_%08X", parent_window->Name, name, id);
+    else
+        ImFormatString(title, IM_ARRAYSIZE(title), "%s/%08X", parent_window->Name, id);
+
+    const float backup_border_size = g.Style.ChildBorderSize;
+    if (!border)
+        g.Style.ChildBorderSize = 0.0f;
+    bool ret = Begin(title, NULL, flags);
+    g.Style.ChildBorderSize = backup_border_size;
+
+    ImGuiWindow* child_window = g.CurrentWindow;
+    child_window->ChildId = id;
+    child_window->AutoFitChildAxises = (ImS8)auto_fit_axises;
+
+    // Set the cursor to handle case where the user called SetNextWindowPos()+BeginChild() manually.
+    // While this is not really documented/defined, it seems that the expected thing to do.
+    if (child_window->BeginCount == 1)
+        parent_window->DC.CursorPos = child_window->Pos;
+
+    // Process navigation-in immediately so NavInit can run on first frame
+    if (g.NavActivateId == id && !(flags & ImGuiWindowFlags_NavFlattened) && (child_window->DC.NavLayerActiveMask != 0 || child_window->DC.NavHasScroll))
+    {
+        FocusWindow(child_window);
+        NavInitWindow(child_window, false);
+        SetActiveID(id + 1, child_window); // Steal ActiveId with another arbitrary id so that key-press won't activate child item
+        g.ActiveIdSource = ImGuiInputSource_Nav;
+    }
+    return ret;
 }
 
 bool ImGui::BeginChild(const char* str_id, const ImVec2& size_arg, bool border, ImGuiWindowFlags extra_flags)
 {
-   ImGuiWindow* window = GetCurrentWindow();
-   return BeginChildEx(str_id, window->GetID(str_id), size_arg, border, extra_flags);
+    ImGuiWindow* window = GetCurrentWindow();
+    return BeginChildEx(str_id, window->GetID(str_id), size_arg, border, extra_flags);
 }
 
 bool ImGui::BeginChild(ImGuiID id, const ImVec2& size_arg, bool border, ImGuiWindowFlags extra_flags)
 {
-   IM_ASSERT(id != 0);
-   return BeginChildEx(NULL, id, size_arg, border, extra_flags);
+    IM_ASSERT(id != 0);
+    return BeginChildEx(NULL, id, size_arg, border, extra_flags);
 }
 
 void ImGui::EndChild()
 {
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   IM_ASSERT(window->Flags & ImGuiWindowFlags_ChildWindow);   // Mismatched BeginChild()/EndChild() callss
-   if (window->BeginCount > 1)
-   {
-      End();
-   }
-   else
-   {
-      // When using auto-filling child window, we don't provide full width/height to ItemSize so that it doesn't feed back into automatic size-fitting.
-      ImVec2 sz = GetWindowSize();
-      if (window->AutoFitChildAxises & (1 << ImGuiAxis_X)) // Arbitrary minimum zero-ish child size of 4.0f causes less trouble than a 0.0f
-         sz.x = ImMax(4.0f, sz.x);
-      if (window->AutoFitChildAxises & (1 << ImGuiAxis_Y))
-         sz.y = ImMax(4.0f, sz.y);
-      End();
-
-      ImGuiWindow* parent_window = g.CurrentWindow;
-      ImRect bb(parent_window->DC.CursorPos, parent_window->DC.CursorPos + sz);
-      ItemSize(sz);
-      if ((window->DC.NavLayerActiveMask != 0 || window->DC.NavHasScroll) && !(window->Flags & ImGuiWindowFlags_NavFlattened))
-      {
-         ItemAdd(bb, window->ChildId);
-         RenderNavHighlight(bb, window->ChildId);
-
-         // When browsing a window that has no activable items (scroll only) we keep a highlight on the child
-         if (window->DC.NavLayerActiveMask == 0 && window == g.NavWindow)
-            RenderNavHighlight(ImRect(bb.Min - ImVec2(2, 2), bb.Max + ImVec2(2, 2)), g.NavId, ImGuiNavHighlightFlags_TypeThin);
-      }
-      else
-      {
-         // Not navigable into
-         ItemAdd(bb, 0);
-      }
-   }
+    ImGuiContext& g = *GImGui;
+    ImGuiWindow* window = g.CurrentWindow;
+
+    IM_ASSERT(g.WithinEndChild == false);
+    IM_ASSERT(window->Flags & ImGuiWindowFlags_ChildWindow);   // Mismatched BeginChild()/EndChild() calls
+
+    g.WithinEndChild = true;
+    if (window->BeginCount > 1)
+    {
+        End();
+    }
+    else
+    {
+        ImVec2 sz = window->Size;
+        if (window->AutoFitChildAxises & (1 << ImGuiAxis_X)) // Arbitrary minimum zero-ish child size of 4.0f causes less trouble than a 0.0f
+            sz.x = ImMax(4.0f, sz.x);
+        if (window->AutoFitChildAxises & (1 << ImGuiAxis_Y))
+            sz.y = ImMax(4.0f, sz.y);
+        End();
+
+        ImGuiWindow* parent_window = g.CurrentWindow;
+        ImRect bb(parent_window->DC.CursorPos, parent_window->DC.CursorPos + sz);
+        ItemSize(sz);
+        if ((window->DC.NavLayerActiveMask != 0 || window->DC.NavHasScroll) && !(window->Flags & ImGuiWindowFlags_NavFlattened))
+        {
+            ItemAdd(bb, window->ChildId);
+            RenderNavHighlight(bb, window->ChildId);
+
+            // When browsing a window that has no activable items (scroll only) we keep a highlight on the child
+            if (window->DC.NavLayerActiveMask == 0 && window == g.NavWindow)
+                RenderNavHighlight(ImRect(bb.Min - ImVec2(2, 2), bb.Max + ImVec2(2, 2)), g.NavId, ImGuiNavHighlightFlags_TypeThin);
+        }
+        else
+        {
+            // Not navigable into
+            ItemAdd(bb, 0);
+        }
+    }
+    g.WithinEndChild = false;
 }
 
